#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <libspe2.h>
#include <pthread.h>

typedef struct spe_args {
	unsigned long long a; //]ɂ64bit̃AhXKv
	unsigned long long b;
	int c;
	int pad[3];
} spe_args_t;

int main(int argc, char** argv){
	char a[13]__attribute__((aligned(16)));
	char b[13]__attribute__((aligned(16)));
	char *p = (char*)a;
	char *q = (char*)b;
	
	int ret, i;
	spe_context_ptr_t spe;
	spe_stop_info_t spe_si;
	spe_program_handle_t *pgmhdl;
	spe_args_t speargs __attribute__((aligned(16)));
	unsigned int entry = SPE_DEFAULT_ENTRY;
	
	for(i = 0; i < 13; i++){
		*p = i + 97;
		p++;
		*q = i + 13 + 97;
		q++;
	}

	printf("PPE output:\n");
	for(i = 0; i < 13; i++){
		printf("%c", a[i]);
	}
	printf("\n");
	for(i = 0; i < 13; i++){
		printf("%c", b[i]);
	}
	printf("\n___end___\n");

	if ((pgmhdl = spe_image_open("s_ldma")) == NULL) {
		perror("spe_image_open");
		exit(EXIT_FAILURE);
	}

	speargs.a = (unsigned long) a;
	speargs.b = (unsigned long) b;
	speargs.c = 100;
	
	if ((spe = spe_context_create(0, NULL)) == NULL) {
		perror("spe_context_create");
		exit(EXIT_FAILURE);
	}
	if (spe_program_load(spe, pgmhdl) < 0) {
		perror("spe_program_load");
		exit(EXIT_FAILURE);
	}

	ret = spe_context_run(spe, &entry, 0, &speargs, NULL, &spe_si);
	if (ret < 0) {
		perror("spe_context_run");
		exit(EXIT_FAILURE);
	}

	ret = spe_context_destroy(spe);
	if (ret) {
		perror("spe_context_destroy");
		exit(EXIT_FAILURE);
	}
	
	return EXIT_SUCCESS;
}

