#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libspe2.h>

#include <pthread.h>
#include "barrier.h"

#define SPE_ALIGN	16
#define NSPE		6
#define STEP		10 //K10
// 32byte
typedef struct spe_args {
	unsigned long long a;
	unsigned long long b;
	int id;
	int pad[3];
} spe_args_t;

typedef enum tm_state {
	TM_READY,
	TM_DONE,
	MAX_TM,
} tm_state_t;

typedef struct thread_manage {
	tm_state_t status;
//	pthread_mutex_t mut;
//	pthread_cond_t cond;
} thread_manage_t;

typedef struct spe_thread_args {
	spe_context_ptr_t spe;
	spe_stop_info_t* spe_si;
	unsigned int entry;
	spe_args_t* speargs;
	thread_manage_t *tm;
} spe_thread_args_t;

static thread_manage_t spe_tm[NSPE];

static void* run_spe(void* args);
static void do_step();
int *a;
int *b;
barrier_t barrier;

int main(int argc, char** argv) {
	int i, ret;
	void *memalloc;
	pthread_t thread[NSPE];

	spe_context_ptr_t spe[NSPE];
	spe_stop_info_t spe_si[NSPE];
	spe_program_handle_t *pgmhdl;
	spe_args_t speargs[NSPE] __attribute__((aligned(16)));
	spe_thread_args_t stargs[NSPE];

	// I alignment  16 ɂ̈mۂ
	if (posix_memalign(&memalloc, SPE_ALIGN, 6*16*sizeof(int)) != 0) {
		perror("posix_memalign");
		exit(EXIT_FAILURE);
	}
	a = (int*) memalloc;

	if (posix_memalign(&memalloc, SPE_ALIGN, 6*16*sizeof(int)) != 0) {
		perror("posix_memalign");
		exit(EXIT_FAILURE);
	}
	b = (int*) memalloc;

	// KɒlƂ`
	for (i = 0; i < 6*16; i++) {
		a[i] = i;
		b[i] = i + 6*16;
	}

	barrier_init(&barrier, NSPE+1);
	if ((pgmhdl = spe_image_open("s_reuse")) == NULL) {
		perror("spe_image_open");
		exit(EXIT_FAILURE);
	}

	for (i = 0; i < NSPE; i++) {
		// SPE CONTEXT ̍쐬ASPE PROGRAM ̃[h
		if (!(spe[i] = spe_context_create(0, NULL))) {
			perror("spe_context_create");
			exit(EXIT_FAILURE);
		}
		if ((spe_program_load(spe[i], pgmhdl))) {
			perror("spe_program_load");
			exit(EXIT_FAILURE);
		}

		stargs[i].spe = spe[i];
		stargs[i].spe_si = &(spe_si[i]);
		stargs[i].entry = SPE_DEFAULT_ENTRY;
		stargs[i].speargs = &(speargs[i]);
		stargs[i].tm = &(spe_tm[i]);

		spe_tm[i].status = TM_READY;

		speargs[i].a = (unsigned long)a;
		speargs[i].b = (unsigned long)b;
		speargs[i].id = i;

		// Thread 쐬
		if (pthread_create(&thread[i], NULL, run_spe, &(stargs[i])) != 0) {
			perror("pthread_create");
			exit(EXIT_FAILURE);
		}

	}
	for (i = 0; i < STEP; i++) {
		do_step();
	}

	for (i = 0; i < NSPE; i++) {
		// Xbh̏I
		spe_tm[i].status = TM_DONE;
	}
	barrier_wait(&barrier);
	barrier_destroy(&barrier);

	for (i = 0; i < NSPE; i++) {
		pthread_join(thread[i], NULL);
	}	

	// SPE CONTEXT j
	for (i = 0; i < NSPE; i++) {
		ret = spe_context_destroy(spe[i]);
		if (ret) {
			perror("spe_context_destroy");
			exit(EXIT_FAILURE);
		}
	}
	return EXIT_SUCCESS;
}

static void do_step() {
	static int s = 0;
	int i;

	printf("step %d\n", s);
	barrier_wait(&barrier);
	
	// mF̂߂̏o
	for(i = 0; i < 6*16; i+=16){
		printf("%d ", a[i]);		
	}
	printf("\n");
	for(i = 0; i < 6*16; i+=16){
		printf("%d ", b[i]);		
	}
	printf("\n");
	s++;
}

static void *run_spe(void* args) {
	int ret;
	spe_thread_args_t *stargs = (spe_thread_args_t*) args;

	while (1) {
		//ׂẴXbhɂǂ蒅܂őҋ@
		barrier_wait(&barrier);

		//TM_DONE ɂȂĂ΁AXebvIƂɂȂ̂Ń[v𔲂
		if (stargs->tm->status == TM_DONE)
			break;

		ret = spe_context_run(stargs->spe, &(stargs->entry), 0, stargs->speargs,
				NULL, stargs->spe_si);
		if (ret < 0) {
			perror("spe_context_run");
		}
				
		//vOJnʒu
		stargs->entry = SPE_DEFAULT_ENTRY;
	}
	return NULL;
}

